/*
 * jQuery MyCalendar ver 1.00
 * copyright@http://studio-key.com/
 * 
 */

(function($){
  
  $.fn.myCalendar = function(options) {
    var settings = $.extend( {
      week: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
      format:'yy/mm/dd',
      mover:false,
      gholiday:false,
      LinkFormat:'yy-mm-dd',
      LinkParam:'?ymd=',
      DayText:false
    }, options);
    
    var selecter = this.selector;

/*
 * トリガー無しでカレンダーをページに表示する
 */
    if(settings.display == 'browse'){
      $(".myCalendar").hide();
      var date   = new Date();
      var yy     = date.getFullYear();
      var mm     = date.getMonth()+1;
      var offset = $( this ).offset();
      var top    = Math.ceil(offset.top)+35;
      var left   = Math.ceil(offset.left);
      var id     = $(this).attr('id');
      var val    = $(this).val();

      Calendar(yy,mm,top,left,id);
    }


/*
 * カレンダーを閉じる
 */
    $(document).on('click',selecter,function(){
      $(".myCalendar").hide();
    });
    
/*
 * 月末を得る
 */
    function lastDay(yy, mm){
      var dt = new Date(yy, mm, 0);
      return dt.getDate();
    }

/*
 * 今月のカレンダー展開
 */
    $(document).on('click',selecter,function(){ 
      $(".myCalendar").hide();
      var date   = new Date();
      var yy     = date.getFullYear();
      var mm     = date.getMonth()+1;
      var offset = $( this ).offset();
      var top    = Math.ceil(offset.top)+35;
      var left   = Math.ceil(offset.left);
      var id     = $(this).attr('id');
      var val    = $(this).val();
      
      //入力後の再クリックの場合は日付に合わせて年月を変更する
      if(val){
        var str = (val).replace(/[^0-9]/g, '');
            yy = str.slice(0,4)|0;
            mm = str.slice(4,6)|0; 
      }


      if(settings.display != 'browse'){
        $('body').append('<p class="dummyClick"></p>');
      }
      
      Calendar(yy,mm,top,left,id);
    });
    
    $(document).on('click','.dummyClick',function(){
      $('p.dummyClick').remove();
      $(".myCalendar").hide();
    });
    
/*
 * マウスオーバー有効の場合はフォームへ日付を入れる
 */
    $(document).on('mouseover',".mycld_r",function(){
      if(settings.mover === true){
        var year   = $(".myCalendar").data("year");
        var month  = $(".myCalendar").data("month")|0;
        var day    = $(this).attr('id')|0;
        var format = settings.format;
        if(day < 10)   day = '0'+day;
        if(month < 10) month = '0'+month;

        format = format.replace("yy", year);
        format = format.replace("mm", month);
        format = format.replace("dd", day);

        var fid  = $(".myCalendar").data("fid");
        $("#"+fid).val(format);
      }
    });
    
    
/*
 * 日をクリックでフォームへ日付を入れ、カレンダーを閉じる
 */
    $(document).on('click',".mycld_r",function(){
      if(settings.display == 'browse') return; 
      var year   = $(".myCalendar").data("year");
      var month  = $(".myCalendar").data("month")|0;
      var day    = $(this).attr('id')|0;
      var format = settings.format;
      if(day < 10)   day = '0'+day;
      if(month < 10) month = '0'+month;
      
      format = format.replace("yy", year);
      format = format.replace("mm", month);
      format = format.replace("dd", day);
      
      var fid  = $(".myCalendar").data("fid");
      $("#"+fid).val(format);
      $(".myCalendar").hide();
    });
    
    
/*
 * 月を進める
 */

    $(document).on('click',".mycld_clt_r",function(){
      $(".myCalendar").hide();
      
      var year  = $(".myCalendar").data("year");
      var month = $(".myCalendar").data("month");
      var top   = $(".myCalendar").data("top");
      var left  = $(".myCalendar").data("left");
      
      if( month == 12){
        year = year+1;
        month = 1;
      }else{
        month = month+1;
      }
      Calendar(year,month,top,left);
      
    });
    
/*
 * 月を戻す
 */
    $(document).on('click',".mycld_clt_l",function(){
      $(".myCalendar").hide();
      
      var year  = $(".myCalendar").data("year");
      var month = $(".myCalendar").data("month");
      var top   = $(".myCalendar").data("top");
      var left  = $(".myCalendar").data("left");
      
      if( month == 1){
        year = year-1;
        month = 12;
      }else{
        month = month-1;
      }
      
      Calendar(year,month,top,left);
    });
    
    
/*
 * calendaer.phpから祭日を取得する
 */
      function Holiday(yy,mm){
        var holidayArray = new Array;
            $.ajax({
                type: "GET",
                async:false,
                url: "calendar.php",
                data: "y="+yy+"&m="+mm,
                success: function(xml){
                   $(xml).find("item").each(function(){
                        //var title = $(this).find("title").text();
                        holidayArray[$(this).find("date").text()] = $(this).find("title").text();
                   });
                }
            });
            
            return holidayArray;
      }
    
    
/*
 * カレンダーボックスの展開
 */

      function Calendar(yy,mm,top,left,id){
        
        var holidayArray = new Array;
        if(settings.gholiday == true){
          holidayArray = Holiday(yy,mm);
        }

        
        var last = lastDay(yy,mm);
        var week = settings.week;
        var start_Date = null;
        var end_Date = null;

        
        //開始日
          if(settings.start){
            if(settings.start == 'today'){
              var sdate = new Date();
              var s_yy  = sdate.getFullYear();
              var s_mm  = sdate.getMonth()+1;
              var s_dd  = sdate.getDate();
              
              start_Date = new Date(s_yy,s_mm-1,s_dd);
            }else{
              var s_Date     = settings.start.split("-");
                  start_Date = new Date(s_Date[0],s_Date[1]-1,s_Date[2]);
            }
          }
          
        //終了日
          if(settings.end){
              var e_Date   = settings.end.split("-");
                  end_Date = new Date(e_Date[0],e_Date[1]-1,e_Date[2]);
          }
        
       //曜日を得て最初の空白行数を計算
        var dt    = new Date(yy,mm-1,1);
        var blank = dt.getDay();
        
        var html = '';
          html +='    <div class="myCalendar" data-year="" data-month="" data-top="" data-left="" data-fid="" >';
          html +='      <div class="mycld_wrap">';
          html +='        <div class="mycld_control">';
          html +='          <div class="mycld_clt_l">&lt;</div>';
          html +='          <div class="mycld_clt_c">'+yy+' - '+mm+'</div>';
          html +='          <div class="mycld_clt_r">&gt;</div>';
          html +='        </div>';
          html +='        <div class="mycld_head">';
          
          for(var i=0; i<week.length; i++){
            html +='          <div class="mycld_week mycld_c">'+week[i]+'</div>';
          }
          
          html +='        </div>';
          html +='        <div class="mycld_day_wrap">';
          
          for(var i=0; i<blank; i++){
            html +='          <div class="mycld_not">&nbsp;</div>';
          }
          
          for(var i=1; i<=last; i++){
            var to = new Date(yy,mm-1,i);
            var view_Flag = null;
            var week = to.getDay();
            var day_Search = false;
            
            var setMM = mm;
            if(mm<10){
              setMM = '0'+mm;
            }
            var setDD = i;
            if(i<10){
              setDD = '0'+i;
            }
            
            var holidays_Date = yy+''+setMM+''+setDD;
            var flagHoliday = '';
            if(settings.gholiday == true){
              if(holidayArray[holidays_Date]){
                flagHoliday = holidayArray[holidays_Date];
              }
            }
            
              var this_DDD  = to.getDate();
              if(this_DDD < 10) this_DDD = '0'+this_DDD;
              if(mm < 10) {
                var mm2 = '0'+mm;
              }else{
                var mm2 = mm;
              }
              var YMD      = ''+yy+''+mm2+''+this_DDD;
            
            if(settings.holiday){

              var stg = settings.holiday;
              var search = stg.indexOf(YMD);
              if(search != -1){
                day_Search = true;
              }
            }
            
            
            //開始日と終了日がどちらも有効
              if( start_Date != null && end_Date != null ){
                if(to.getTime() >= start_Date.getTime() && to.getTime() <= end_Date.getTime() ) { 
                  html += not(true,i,week,day_Search,flagHoliday,YMD);
                }else{
                  html += not(false,i,week,day_Search,flagHoliday,YMD);
                }
              }
            //開始日だけ有効
              else if( start_Date != null && end_Date == null ){
                
                if(to.getTime() >= start_Date.getTime() ) { 
                  html += not(true,i,week,day_Search,flagHoliday,YMD);
                }else{
                  html += not(false,i,week,day_Search,flagHoliday,YMD);
                }
              }
            //終了日だけ有効
              else if( start_Date == null && end_Date != null ){
                if(to.getTime() <= end_Date.getTime() ) { 
                  html += not(true,i,week,day_Search,flagHoliday,YMD);
                }else{
                  html += not(false,i,week,day_Search,flagHoliday,YMD);
                }
              }
              else{
                html += not(true,i,week,day_Search,flagHoliday,YMD);
              }
            
          }

          html +='        </div>';
          html +='      </div>';
          html +='    </div>';
          
            $("body").append(html);
            $(".myCalendar").css({"top":top,"left":left});

            $(".myCalendar").data("year",yy);
            $(".myCalendar").data("month",mm);
            $(".myCalendar").data("top",top);
            $(".myCalendar").data("left",left);
            
            if(id){
              $(".myCalendar").data("fid",id);
            }
      }
      
      
/*
 * 日付クリックで別ページへ移動する
 * 
 */
      $(document).on('click',".GetLink",function(){
        var year   = $(".myCalendar").data("year");
        var month  = $(".myCalendar").data("month")|0;
        var day    = $(this).attr('id')|0;
        var format = settings.LinkFormat;
        if(day < 10)   day = '0'+day;
        if(month < 10) month = '0'+month;

        format = format.replace("yy", year);
        format = format.replace("mm", month);
        format = format.replace("dd", day);
        
        // クリックした際にページ移動ではなく、Jqueryなどで処理したい場合
        // formatが日付なので、この辺にコードを書く
        // console.log(format) 
        //
        
        if(settings.GetLink){
          var url = settings.GetLink+settings.LinkParam+format;
          location.href=url;
        }
      });
      
/*
 * 日付のHTMLコードを生成する
 */
      function not(flag,i,w,day_Search,flagHoliday,YMD){
       
       //曜日で定休日にする場合など
        if(settings.holidayweek){
          var week = settings.holidayweek.split(",");
          for(var n = 0; n<week.length; n++){
            if(week[n] == w){ //指定した曜日と一緒なら休日にする
              flag = false;
            }
          }
        }
        
        if(day_Search === true){
          flag = false;
        }
        
      //曜日の文字色変更
        var yobi  = '';
        if(w == 0){
          var yobi  = ' f_Su';
        }else if(w == 6){
          var yobi  = ' f_Sa';
        }
      //祭日なら文字色を赤に
        if(flagHoliday){
          var yobi  = ' f_Su';
        }
         
        var dayStr = '';
        if(settings.DayText){
          var dayStr = '<div class="setText">'+flagHoliday+'</div>';
        }
            

        if(flag === true){
          return '<div title="'+flagHoliday+'" class="mycld_days mycld_r'+yobi+' GetLink" id="'+i+'" data-ymd="'+YMD+'">'+i+''+dayStr+'</div>';
        }else{
          return '<div class="mycld_not'+yobi+'" id="'+i+'">'+i+''+dayStr+'</div>';
        }
      }
    
  };
})(jQuery);

/*
 * indexOf (IE)
 */
if (!Array.prototype.indexOf){
  Array.prototype.indexOf = function(elt){
    var len = this.length;

    var from = Number(arguments[1]) || 0;
    from = (from < 0)
         ? Math.ceil(from)
         : Math.floor(from);
    if (from < 0)
      from += len;

    for (; from < len; from++){
      if (from in this &&
          this[from] === elt)
        return from;
    }
    return -1;
  };
}